#include <iostream>
#include <string>
#include <algorithm>

#define endl '\n'

using namespace std;

const uint64_t INF = 1e9;

string convert_num_to_base(uint64_t target, uint64_t base) {
    string res = "";

    while (target > 0) {
        int curr = target % base;
        target /= base;

        res += (curr + '0');
    }

    reverse(res.begin(), res.end());
    return res;
}

uint64_t convert_base_to_num(string& num, uint64_t base) {
    int n = (int) num.size();

    uint64_t res = 0, mul = 1;
    for (int i = n - 1; i >= 0; --i) {
        res += (num[i] - '0') * mul;
        mul *= base;
    }

    return res;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    uint64_t target;
    cin >> target;

    for (uint64_t num = target; num < INF; num += target) {
        string binary = convert_num_to_base(num, 2);
        uint64_t ternary = convert_base_to_num(binary, 3);

        if (ternary % target == 0) {
            cout << binary << endl;
            return 0;
        }
    }

    cout << "NO\n";
return 0;
}
