#include <iostream>
#include <set>
#include <utility>
#include <vector>

#define endl '\n'

using namespace std;

const int INF = 503;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<vector<int>> process_time(n, vector<int>(2, 0));
    for (int type = 0; type < 2; ++type) {
        for (int i = 0; i < n; ++i) {
            cin >> process_time[i][type];
        }
    }

    multiset<pair<int, int>> available;
    for (int i = 0; i < n; ++i) {
        available.insert({process_time[i][0], process_time[i][1]});
    }

    pair<int, int> curr_detail = *available.begin();
    available.erase(available.begin());

    int first_machine_time = curr_detail.first;
    int second_machine_time = first_machine_time + curr_detail.second;
    int delay = 0;

    for (int i = 1; i < n; ++i) {
        auto it = available.upper_bound({curr_detail.second, INF});

        if (it == available.end()) {
            --it;
        }
        pair<int, int> next_detail = *it;

        if (it != available.begin()) {
            --it;
            next_detail = *it;
        }

        //cout << "(" << curr_detail.first << ", " << curr_detail.second << ") -> (" <<next_detail.first << ", " << next_detail.second << ")\n";

        first_machine_time += next_detail.first;
        second_machine_time += next_detail.second;

        int diff = next_detail.first - curr_detail.second - delay;
        if (diff < 0) {
            delay = -diff;
        } else {
            second_machine_time += diff;
            delay = 0;
        }

        curr_detail = next_detail;
        available.erase(it);
    }

    cout << second_machine_time << endl;
return 0;
}
