#include <iostream>
#include <vector>
#include <algorithm>

#define endl '\n'

using namespace std;

void shift_array_right(int target, vector<int>& nums, int n) {
    for (int i = target; i > 0; --i) {
        nums[i] = nums[i - 1];
    }
}

void shift_array_left(int target, vector<int>& nums, int n) {
    for (int i = 0; i < target; ++i) {
        nums[i] = nums[i + 1];
    }
}

vector<int> res;

bool brute_force(int steps, vector<int>& nums, int n) {
    if (is_sorted(nums.begin(), nums.end())) {
        cout << (int) res.size() << endl;
        for (int curr : res) {
            cout << curr << " ";
        }
        cout << endl;

        return true;
    }

    if (steps == n * n) {
        return false;
    }

    int max_number = nums[0];
    for (int i = 1; i < n; ++i) {
        if ((i & (i + 1)) == 0 and nums[i] < max_number) {
            int new_value = nums[i];
            shift_array_right(i, nums, n);

            nums[0] = new_value;
            res.push_back(i + 1);

            // cout << steps << " " << i << " " << n << " " << res.back() << endl;

            if (brute_force(steps + 1, nums, n)) {
                return true;
            }

            shift_array_left(i, nums, n);
            nums[i] = new_value;
            res.pop_back();
        }

        max_number = max(max_number, nums[i]);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> nums(n);
    for (int i = 0; i < n; ++i) {
        cin >> nums[i];
    }

    res.clear();
    brute_force(0, nums, n);
return 0;
}
