#include <iostream>
#include <vector>
#include <algorithm>

#define endl '\n'

using namespace std;

void shift_array_right(int target, vector<int>& nums, int n) {
    for (int i = target; i > 0; --i) {
        nums[i] = nums[i - 1];
    }
}

void shift_array_left(int target, vector<int>& nums, int n) {
    for (int i = 0; i < target; ++i) {
        nums[i] = nums[i + 1];
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> nums(n);
    for (int i = 0; i < n; ++i) {
        cin >> nums[i];
    }

    vector<int> steps;
    for (int step = 0; step < n * n; ++step) {
        bool is_inversion = false;
        int first_possible_pos = -1;

        bool is_change = false;
        for (int i = 0; i < n and !is_change; ++i) {
            is_inversion |= (i > 0 and nums[i] < nums[i - 1]);
            if ((i & (i + 1)) != 0 or !is_inversion) {
                continue;
            }

            if (first_possible_pos == -1) {
                first_possible_pos = i;
            }
            if (nums[i] == 2) {
                continue;
            }

            shift_array_right(i, nums, n);
            nums[0] = 1;

            is_change = true;
            steps.push_back(i + 1);
        }

        if (!is_change and is_inversion and first_possible_pos != -1) {
            shift_array_right(first_possible_pos, nums, n);
            nums[0] = 2;

            steps.push_back(first_possible_pos + 1);
        }
    }

    cout << (int) steps.size() << endl;
    for (int curr : steps) {
        cout << curr << " ";
    }
return 0;
}
