#include <bits/stdc++.h>

//#define DEBUG

#define MAX_N 128
#define MAX_K 16384
#define nl '\n'
#define POW(X) ((X) < 0 ? 0 : 1 << (X))

int n, nlevel;
int arr[MAX_N];
int ends[8];

int k = 0;
int ans[MAX_K];

void swp_(int n) {
    if (n == 0) return;
    if (n == 1) {
        std::swap(arr[0], arr[1]);
        return;
    }
    std::swap(arr[ends[n]], arr[ends[n - 1]]);
    if (--ends[n] == POW(n - 1) - 1) ends[n] = POW(n) - 1;
    swp_(n - 1);
}

void print_arr() {
#ifdef DEBUG
    for(int i = 0; i <= nlevel; ++i) {
        for (int j = ends[i] + 1; ; ++j) {
            if (j > POW(i) - 1) j = POW(i - 1);
            std::cout << arr[j] << ' ';
            if (j == ends[i]) break;
        }
    }
    std::cout << std::endl;
#endif
}

void swp(int n) {
    if (n == 0) return;
    ans[k++] = POW(n);
    swp_(n);
    print_arr();
}

char used[MAX_N];

bool get_used(int n, int by) {
    return used[n] & (1 << by);
}

void set_used(int n, int by) {
    used[n] |= (1 << by);
}

void subtask1() {
    if (arr[0] > arr[1]) swp(1);
}

void subtask2() {
    while (arr[1] != 4) swp(2);
    while (arr[0] != 3) {swp(1); swp(2);}
    swp(2);
    swp(2);
    subtask1();
}

void range(int level, int l, int r) {
    for (int i = 0; i < POW(level + 1); ++i) {
        if (arr[ends[level]] < l || arr[ends[level]] >= r) swp(level + 1);
        else swp(level);
    }
}

void move(int level) {
        for (int i = 0; i < POW(level - 1); ++i) swp(level);
}

void solve(int level, int l, int r) {
    if (level == 0) return;
    int m = (l + r) / 2;
    range(level - 1, m, r);
    solve(level - 1, m, r);
    move(level);
    solve(level - 1, l, m);
}

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);

    std::cin >> n;
    for (int i = 0; i < n; ++i) {
        std::cin >> arr[i];
        --arr[i];
    }
    for (int i = 0; i < 8; ++i) ends[i] = POW(i) - 1;
    for (; n > 1; n /= 2) ++nlevel;

    solve(nlevel, 0, POW(nlevel));
    //range(1, 2, 4);

    std::cout << k << nl;
    for (int i = 0; i < k; ++i) std::cout << ans[i] << ' ';
}
