#include <bits/stdc++.h>

//#define DEBUG

#define MAX_N 128
#define MAX_K 16384
#define nl '\n'
#define POW(X) ((X) < 0 ? 0 : 1 << (X))

int n, nlevel;
int arr[MAX_N];
int ends[8];

int k = 0;
int ans[MAX_K];

void swp_(int n) {
    if (n == 0) return;
    if (n == 1) {
        std::swap(arr[0], arr[1]);
        return;
    }
    std::swap(arr[ends[n]], arr[ends[n - 1]]);
    if (--ends[n] == POW(n - 1) - 1) ends[n] = POW(n) - 1;
    swp_(n - 1);
}

void print_arr() {
    for(int i = 0; i <= nlevel; ++i) {
        for (int j = ends[i] + 1; ; ++j) {
            if (j > POW(i) - 1) j = POW(i - 1);
            std::cout << arr[j] + 1 << ' ';
            if (j == ends[i]) break;
        }
    }
    std::cout << std::endl;
}

bool check_arr() {
    int to_check[n];
    int len = 0;
    for(int i = 0; i <= nlevel; ++i) {
        for (int j = ends[i] + 1; ; ++j) {
            if (j > POW(i) - 1) j = POW(i - 1);
            to_check[len++] = arr[j];
            if (j == ends[i]) break;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (to_check[i] != i) return true;
    }
    return false;
}


void swp(int n) {
    if (n == 0) return;
    ans[k++] = POW(n);
    swp_(n);
#ifdef DEBUG
    print_arr();
#endif
}

void swp_begin(int ind) {
    if (ind == 0) return;

    int dist;

    dist = n - ind;
    for (int i = 8; i > 0;) if (POW(i) - 1 <= dist) {
        for (int j = 0; j < POW(i) - 1; ++j) swp(nlevel);
        swp(i);
        dist -= POW(i) - 1;
    } else {
        --i;
    }

    swp(1);

    dist = ind - 1;
    for (int i = 8; i > 0;) if (POW(i) - 1 <= dist) {
        for (int j = 0; j < POW(i) - 1; ++j) swp(nlevel);
        swp(i);
        dist -= POW(i) - 1;
    } else {
        --i;
    }
}

int find_ind(int v) {
    int ans = 0;
    for(int i = 0; i <= nlevel; ++i) {
        for (int j = ends[i] + 1; ; ++j) {
            if (j > POW(i) - 1) j = POW(i - 1);
            if (arr[j] == v) return ans;
            ++ans;
            if (j == ends[i]) break;
        }
    }
}

void solve() {
    for (int i = n - 1; i >= 0; --i) {
        swp_begin(find_ind(i));
        if (i != 0) swp(nlevel);
        //std::cout << "------------------------\n";
    }
}

int log(int n) {
    int ans = 0;
    for (; n > 1; n /= 2) ++ans;
    return ans;
}

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);

    std::cin >> n;
    nlevel = log(n);

    int perm_arr[n];
    for (int i = 0; i < n; ++i) {
        std::cin >> arr[i];
        --arr[i];
        //arr[i] = i;
        //perm_arr[i] = i;
    }
/*
    do {
        k = 0;
        for (int i = 0; i < n; ++i) arr[i] = perm_arr[i];
        for (int i = 0; i < 8; ++i) ends[i] = POW(i) - 1;
        solve(nlevel, 0, n);
        if(check_arr()) {
            std::cout << "WA @ ";
            for (int i = 0; i < n; ++i) std::cout << perm_arr[i] << ' ';
            std::cout << ": ";
            for (int i = 0; i < n; ++i) std::cout << arr[i] << ' ';
            std::cout << nl;
            return 0;
        }
    } while (std::next_permutation(perm_arr, perm_arr + n));
*/

    for (int i = 0; i < 8; ++i) ends[i] = POW(i) - 1;
    solve();

    std::cout << k << nl;
    //print_arr();
    for (int i = 0; i < k; ++i) std::cout << ans[i] << ' ';
}

/**
|| |   |       |
2....1----------

|| |   |       |
1....2----------

|| |   |       |
1....2----------


**/
