#include <bits/stdc++.h>
//#define DEBUG

#define MAX_N 128
#define MAX_K 16384
#define nl '\n'
#define POW(X) ((X) < 0 ? 0 : 1 << (X))

int n, nlevel;
int arr[MAX_N];
int ends[8];
int k = 0;
int ans[MAX_K];

void swp_(int n) {
    if (n == 0) return;
    if (n == 1) {
        std::swap(arr[0], arr[1]);
        return;
    }
    std::swap(arr[ends[n]], arr[ends[n - 1]]);
    if (--ends[n] == POW(n - 1) - 1) ends[n] = POW(n) - 1;
    swp_(n - 1);
}

void print_arr() {
    for(int i = 0; i <= nlevel; ++i) {
        for (int j = ends[i] + 1; ; ++j) {
            if (j > POW(i) - 1) j = POW(i - 1);
            std::cout << arr[j] + 1 << ' ';
            if (j == ends[i]) break;
        }
    }
    std::cout << std::endl;
}

bool check_arr() {
    int to_check[n];
    int len = 0;
    for(int i = 0; i <= nlevel; ++i) {
        for (int j = ends[i] + 1; ; ++j) {
            if (j > POW(i) - 1) j = POW(i - 1);
            to_check[len++] = arr[j];
            if (j == ends[i]) break;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (to_check[i] != i) return true;
    }
    return false;
}

void swp(int n) {
    if (n == 0) return;
    ans[k++] = POW(n);
    swp_(n);
#ifdef DEBUG
    print_arr();
#endif
}

void range(int level, int l, int r) {
    int no_big_swp = 0;
    while(true) {
            if (arr[ends[level]] < l || arr[ends[level]] >= r) {
            swp(level + 1);
            no_big_swp = 0;
        }
        else {
            if(++no_big_swp == POW(level)) break;
            swp(level);
        }
    }
}

void move(int level) {
        for (int i = 0; i < POW(level - 1); ++i) swp(level);
}

void solve(int level, int l, int r) {
    if (level == 0) return;
    int m = (l + r) / 2;
    range(level - 1, m, r);
    solve(level - 1, m, r);
    move(level);
    solve(level - 1, l, m);
}

void solve_special() {
    range(nlevel - 1, 1, 2);
    move(nlevel);
    //solve(level - 1, l, m);
}

int log(int n) {
    int ans = 0;
    for (; n > 1; n /= 2) ++ans;
    return ans;
}

int count0, count1;

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cin >> n;
    nlevel = log(n);
    int perm_arr[n];
    for (int i = 0; i < n; ++i) {
        std::cin >> arr[i];
        --arr[i];
        if (arr[i] == 0) ++count0;
        if (arr[i] == 1) ++count1;
        //arr[i] = i;
        //perm_arr[i] = i;
    }
/*
    do {
        k = 0;
        for (int i = 0; i < n; ++i) arr[i] = perm_arr[i];
        for (int i = 0; i < 8; ++i) ends[i] = POW(i) - 1;
        solve(nlevel, 0, n);
        if(check_arr()) {
            std::cout << "WA @ ";
            for (int i = 0; i < n; ++i) std::cout << perm_arr[i] << ' ';
            std::cout << ": ";
            for (int i = 0; i < n; ++i) std::cout << arr[i] << ' ';
            std::cout << nl;
            return 0;
        }
    } while (std::next_permutation(perm_arr, perm_arr + n));
*/
    for (int i = 0; i < 8; ++i) ends[i] = POW(i) - 1;
    if (count1 + count0 == n && count1 == count0) solve_special(); else solve(nlevel, 0, n);
    std::cout << k << nl;
    //print_arr();
    for (int i = 0; i < k; ++i) std::cout << ans[i] << ' ';
}
